/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */

#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

/**************************************************************************************/
void yes_delete_record()
{
	char tstring[250], tstring2[250];
	long records;
	int tint, tint2;
	unsigned long tlong, tlong2, tlong3;
	float tfloat, tfloat2, tfloat3, tfloat4;
	FILE *infile, *outfile;
	extern int open_file_flag, data_window_flag;
    	extern char *datapath, *error_message, cant_open_chart[], cant_create_tempfile[];
    	extern char edit_symbol[SYMBOL_SIZE], *global_string, symbol[SYMBOL_SIZE];
    	extern char cant_delete_last_record[];
    	extern long edit_record;
    	extern display_message(), exit_yesno_window(), load_file(), draw(), show_data_window();
    	extern GtkWidget *edit_chart_date_statusbar;
    	extern GtkWidget *edit_chart_open_value_entry, *edit_chart_record_statusbar;
    	extern GtkWidget *edit_chart_high_value_entry, *edit_chart_low_value_entry;
    	extern GtkWidget *edit_chart_close_value_entry, *edit_chart_volume_value_entry;
    	extern GtkWidget *edit_chart_openi_value_entry;
    	
    	
	strcpy(tstring, datapath);
   	strcat(tstring, edit_symbol);
    	infile = fopen(tstring, "rb");
    	if (! infile)
    	{
    		error_message = cant_open_chart;
		display_message();
		return;
    	}
    	fseek(infile, 0L, SEEK_END);
    	tlong = ftell(infile);
    	tlong = tlong - HEADERSIZE;
    	records = tlong / RECORDSIZE;
    	if (records == 1)
    	{
    		fclose(infile);
    		error_message = cant_delete_last_record;
		display_message();
		return;
    	}
    	strcpy(tstring, datapath);
    	strcat(tstring, "temp.dat");
   	outfile = fopen(tstring, "wb");
   	if (! outfile)
    	{
    		error_message = cant_create_tempfile;
		display_message();
		return;
	}
    	fseek(infile, 0L, SEEK_SET);
    	fread(&tstring, NAME_SIZE, 1, infile);
	fread(&tstring2, SYMBOL_SIZE, 1, infile);
	fread(&tint, sizeof(int), 1, infile);
	fread(&tint2, sizeof(int), 1, infile);
	fread(&tfloat, sizeof(float), 1, infile);
	fread(&tfloat2, sizeof(float), 1, infile);
	fread(&tfloat3, sizeof(float), 1, infile);
	fwrite(&tstring, NAME_SIZE, 1, outfile);
	fwrite(&tstring2, SYMBOL_SIZE, 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint2, sizeof(int), 1, outfile);
	fwrite(&tfloat, sizeof(float), 1, outfile);
	fwrite(&tfloat2, sizeof(float), 1, outfile);
	fwrite(&tfloat3, sizeof(float), 1, outfile);
    	for (tint = 1; tint < edit_record; tint++)
    	{
    		fread(&tlong, sizeof(unsigned long), 1, infile);
		fread(&tfloat, sizeof(float), 1, infile);
		fread(&tfloat2, sizeof(float), 1, infile);
		fread(&tfloat3, sizeof(float), 1, infile);
		fread(&tfloat4, sizeof(float), 1, infile);
		fread(&tlong2, sizeof(unsigned long), 1, infile);
		fread(&tlong3, sizeof(unsigned long), 1, infile);
		fwrite(&tlong, sizeof(unsigned long), 1, outfile);
		fwrite(&tfloat, sizeof(float), 1, outfile);
		fwrite(&tfloat2, sizeof(float), 1, outfile);
		fwrite(&tfloat3, sizeof(float), 1, outfile);
		fwrite(&tfloat4, sizeof(float), 1, outfile);
		fwrite(&tlong2, sizeof(unsigned long), 1, outfile);
		fwrite(&tlong3, sizeof(unsigned long),1,outfile);
  	}
  	fread(&tlong, sizeof(unsigned long), 1, infile);
	fread(&tfloat, sizeof(float), 1, infile);
	fread(&tfloat2, sizeof(float), 1, infile);
	fread(&tfloat3, sizeof(float), 1, infile);
	fread(&tfloat4, sizeof(float), 1, infile);
	fread(&tlong2, sizeof(unsigned long), 1, infile);
	fread(&tlong3, sizeof(unsigned long), 1, infile);
	for (tint = edit_record + 1; tint <= records; tint++)
    	{
    		fread(&tlong, sizeof(unsigned long), 1, infile);
		fread(&tfloat, sizeof(float), 1, infile);
		fread(&tfloat2, sizeof(float), 1, infile);
		fread(&tfloat3, sizeof(float), 1, infile);
		fread(&tfloat4, sizeof(float), 1, infile);
		fread(&tlong2, sizeof(unsigned long), 1, infile);
		fread(&tlong3, sizeof(unsigned long), 1, infile);
		fwrite(&tlong, sizeof(unsigned long), 1, outfile);
		fwrite(&tfloat, sizeof(float), 1, outfile);
		fwrite(&tfloat2, sizeof(float), 1, outfile);
		fwrite(&tfloat3, sizeof(float), 1, outfile);
		fwrite(&tfloat4, sizeof(float), 1, outfile);
		fwrite(&tlong2, sizeof(unsigned long), 1, outfile);
		fwrite(&tlong3, sizeof(unsigned long),1,outfile);
  	}    	
    	fclose(infile);
    	fclose(outfile);
    	strcpy(tstring, datapath);
    	strcat(tstring, edit_symbol);
    	unlink(tstring);
    	strcpy(tstring, datapath);
    	strcat(tstring, "temp.dat");
    	strcpy(tstring2, datapath);
    	strcat(tstring2, edit_symbol);
    	rename(tstring, tstring2);
    	if (edit_record != 1)
    		edit_record--;
    	strcpy(tstring, datapath);
    	strcat(tstring, edit_symbol);
    	infile = fopen(tstring, "rb");
    	fseek(infile, ((long)(edit_record - 1) * RECORDSIZE) + HEADERSIZE, SEEK_SET);
    	fread(&tlong, sizeof(unsigned long), 1, infile);
	fread(&tfloat, sizeof(float), 1, infile);
	fread(&tfloat2, sizeof(float), 1, infile);
	fread(&tfloat3, sizeof(float), 1, infile);
	fread(&tfloat4, sizeof(float), 1, infile);
	fread(&tlong2, sizeof(unsigned long), 1, infile);
	fread(&tlong3, sizeof(unsigned long), 1, infile);
	fclose(infile);
	sprintf(tstring, "%ld", edit_record);
      	strcat(tstring, " / ");
      	sprintf(tstring2, "%ld", records - 1);
      	strcat(tstring, tstring2);
	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_record_statusbar), 1, tstring);
	sprintf(tstring, "%ld", tlong);
	tstring2[0] = tstring[4];
        tstring2[1] = tstring[5];
        tstring2[2] = '/';
        tstring2[3] = tstring[6];
        tstring2[4] = tstring[7];
        tstring2[5] = '/';
        tstring2[6] = tstring[0];
        tstring2[7] = tstring[1];
        tstring2[8] = tstring[2];
        tstring2[9] = tstring[3];
        tstring2[10] = 0;
	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_date_statusbar), 1, tstring2);
	sprintf(tstring, "%6.4f", tfloat);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_open_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_high_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_low_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat4);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_close_value_entry), tstring);
	sprintf(tstring, "%ld", tlong2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_volume_value_entry), tstring);
	sprintf(tstring, "%ld", tlong3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_openi_value_entry), tstring);
	exit_yesno_window();
	
	strcpy(tstring, symbol);
	strcpy(tstring2, edit_symbol);
	if (! strcmp(tstring, tstring2))
	{
		if (global_string != NULL)
			free(global_string);
		global_string = (char *)malloc(sizeof(symbol) + 1);
		strcpy(global_string, symbol);
		tint = open_file_flag;
		open_file_flag = 1;
		load_file();
		open_file_flag = tint;
		draw();
		if (data_window_flag)
			show_data_window();
	}
}
/****************************************************************************************/
void edit_data_end()
{
	char tstring[250], tstring2[25], symbol[25];
	unsigned long tlong, tlong2, tlong3, records;
	float tfloat, tfloat2, tfloat3, tfloat4;
	FILE *infile;
    	extern char *datapath, *error_message, cant_open_chart[], edit_symbol[SYMBOL_SIZE];
    	extern long edit_record;
    	extern display_message();
    	extern GtkWidget *edit_chart_date_statusbar;
    	extern GtkWidget *edit_chart_open_value_entry, *edit_chart_record_statusbar;
    	extern GtkWidget *edit_chart_high_value_entry, *edit_chart_low_value_entry;
    	extern GtkWidget *edit_chart_close_value_entry, *edit_chart_volume_value_entry;
    	extern GtkWidget *edit_chart_openi_value_entry;
    	
	
	if (edit_record == 0)
		return;
	strcpy(symbol, edit_symbol);
	strcpy(tstring, datapath);
   	strcat(tstring, symbol);
    	infile = fopen(tstring, "rb");
    	if (! infile)
    	{
    		error_message = cant_open_chart;
		display_message();
		return;
    	}
    	fseek(infile, 0L, SEEK_END);
    	tlong = ftell(infile);
    	tlong = tlong - HEADERSIZE;
    	records = tlong / RECORDSIZE;
    	fseek(infile, ((long)(records - 1) * RECORDSIZE) + HEADERSIZE, SEEK_SET);
	fread(&tlong, sizeof(unsigned long), 1, infile);
	fread(&tfloat, sizeof(float), 1, infile);
	fread(&tfloat2, sizeof(float), 1, infile);
	fread(&tfloat3, sizeof(float), 1, infile);
	fread(&tfloat4, sizeof(float), 1, infile);
	fread(&tlong2, sizeof(unsigned long), 1, infile);
	fread(&tlong3, sizeof(unsigned long), 1, infile);
	fclose(infile);
	edit_record = records;
      	sprintf(tstring, "%ld", edit_record);
      	strcat(tstring, " / ");
      	sprintf(tstring2, "%ld", records);
      	strcat(tstring, tstring2);
	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_record_statusbar), 1, tstring);
	sprintf(tstring, "%ld", tlong);
        tstring2[0] = tstring[4];
        tstring2[1] = tstring[5];
        tstring2[2] = '/';
        tstring2[3] = tstring[6];
        tstring2[4] = tstring[7];
        tstring2[5] = '/';
        tstring2[6] = tstring[0];
        tstring2[7] = tstring[1];
        tstring2[8] = tstring[2];
        tstring2[9] = tstring[3];
        tstring2[10] = 0;
	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_date_statusbar), 1, tstring2);
	sprintf(tstring, "%6.4f", tfloat);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_open_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_high_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_low_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat4);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_close_value_entry), tstring);
	sprintf(tstring, "%ld", tlong2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_volume_value_entry), tstring);
	sprintf(tstring, "%ld", tlong3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_openi_value_entry), tstring);
}
/****************************************************************************************/
void edit_data_back()
{
	char tstring[250], tstring2[25], symbol[25];
	unsigned long tlong, tlong2, tlong3, records;
	float tfloat, tfloat2, tfloat3, tfloat4;
	FILE *infile;
    	extern char *datapath, *error_message, cant_open_chart[], edit_symbol[SYMBOL_SIZE];
    	extern long edit_record;
    	extern display_message();
    	extern GtkWidget *edit_chart_date_statusbar;
    	extern GtkWidget *edit_chart_open_value_entry, *edit_chart_record_statusbar;
    	extern GtkWidget *edit_chart_high_value_entry, *edit_chart_low_value_entry;
    	extern GtkWidget *edit_chart_close_value_entry, *edit_chart_volume_value_entry;
    	extern GtkWidget *edit_chart_openi_value_entry;
    	
	
	if (edit_record == 0)
		return;
	strcpy(symbol, edit_symbol);
	strcpy(tstring, datapath);
   	strcat(tstring, symbol);
    	infile = fopen(tstring, "rb");
    	if (! infile)
    	{
    		error_message = cant_open_chart;
		display_message();
		return;
    	}
    	fseek(infile, 0L, SEEK_END);
    	tlong = ftell(infile);
    	tlong = tlong - HEADERSIZE;
    	records = tlong / RECORDSIZE;
	if (edit_record - 1 > 0)
    	{
    		edit_record--;
    		fseek(infile, ((long)(edit_record - 1) * RECORDSIZE) + HEADERSIZE, SEEK_SET);
		fread(&tlong, sizeof(unsigned long), 1, infile);
		fread(&tfloat, sizeof(float), 1, infile);
		fread(&tfloat2, sizeof(float), 1, infile);
		fread(&tfloat3, sizeof(float), 1, infile);
		fread(&tfloat4, sizeof(float), 1, infile);
		fread(&tlong2, sizeof(unsigned long), 1, infile);
		fread(&tlong3, sizeof(unsigned long), 1, infile);
		fclose(infile);
		sprintf(tstring, "%ld", edit_record);
      		strcat(tstring, " / ");
      		sprintf(tstring2, "%ld", records);
      		strcat(tstring, tstring2);
		gtk_statusbar_push (GTK_STATUSBAR(edit_chart_record_statusbar),1,tstring);
		sprintf(tstring, "%ld", tlong);
		tstring2[0] = tstring[4];
        	tstring2[1] = tstring[5];
        	tstring2[2] = '/';
        	tstring2[3] = tstring[6];
        	tstring2[4] = tstring[7];
        	tstring2[5] = '/';
        	tstring2[6] = tstring[0];
        	tstring2[7] = tstring[1];
        	tstring2[8] = tstring[2];
        	tstring2[9] = tstring[3];
        	tstring2[10] = 0;
		gtk_statusbar_push (GTK_STATUSBAR(edit_chart_date_statusbar), 1, tstring2);
		sprintf(tstring, "%6.4f", tfloat);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_open_value_entry), tstring);
		sprintf(tstring, "%6.4f", tfloat2);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_high_value_entry), tstring);
		sprintf(tstring, "%6.4f", tfloat3);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_low_value_entry), tstring);
		sprintf(tstring, "%6.4f", tfloat4);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_close_value_entry), tstring);
		sprintf(tstring, "%ld", tlong2);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_volume_value_entry), tstring);
		sprintf(tstring, "%ld", tlong3);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_openi_value_entry), tstring);
	}
}
/****************************************************************************************/
void edit_data_next()
{
	char tstring[250], tstring2[25], symbol[25];
	unsigned long tlong, tlong2, tlong3, records;
	float tfloat, tfloat2, tfloat3, tfloat4;
	FILE *infile;
    	extern char *datapath, *error_message, cant_open_chart[], edit_symbol[SYMBOL_SIZE];
    	extern long edit_record;
    	extern display_message();
    	extern GtkWidget *edit_chart_date_statusbar;
    	extern GtkWidget *edit_chart_open_value_entry, *edit_chart_record_statusbar;
    	extern GtkWidget *edit_chart_high_value_entry, *edit_chart_low_value_entry;
    	extern GtkWidget *edit_chart_close_value_entry, *edit_chart_volume_value_entry;
    	extern GtkWidget *edit_chart_openi_value_entry;
    	
	
	if (edit_record == 0)
		return;
	strcpy(symbol, edit_symbol);
	strcpy(tstring, datapath);
   	strcat(tstring, symbol);
    	infile = fopen(tstring, "rb");
    	if(! infile)
    	{
    		error_message = cant_open_chart;
		display_message();
		return;
    	}
    	fseek(infile, 0L, SEEK_END);
    	tlong = ftell(infile);
    	tlong = tlong - HEADERSIZE;
    	records = tlong / RECORDSIZE;
	if (edit_record + 1 <= records)
    	{
    		edit_record++;
    		fseek(infile, ((long)(edit_record - 1) * RECORDSIZE) + HEADERSIZE, SEEK_SET);
		fread(&tlong, sizeof(unsigned long), 1, infile);
		fread(&tfloat, sizeof(float), 1, infile);
		fread(&tfloat2, sizeof(float), 1, infile);
		fread(&tfloat3, sizeof(float), 1, infile);
		fread(&tfloat4, sizeof(float), 1, infile);
		fread(&tlong2, sizeof(unsigned long), 1, infile);
		fread(&tlong3, sizeof(unsigned long), 1, infile);
		fclose(infile);
		sprintf(tstring, "%ld", edit_record);
      		strcat(tstring, " / ");
      		sprintf(tstring2, "%ld", records);
      		strcat(tstring, tstring2);
		gtk_statusbar_push (GTK_STATUSBAR(edit_chart_record_statusbar),1,tstring);
		sprintf(tstring, "%ld", tlong);
		tstring2[0] = tstring[4];
        	tstring2[1] = tstring[5];
        	tstring2[2] = '/';
        	tstring2[3] = tstring[6];
        	tstring2[4] = tstring[7];
        	tstring2[5] = '/';
        	tstring2[6] = tstring[0];
        	tstring2[7] = tstring[1];
        	tstring2[8] = tstring[2];
        	tstring2[9] = tstring[3];
        	tstring2[10] = 0;
		gtk_statusbar_push (GTK_STATUSBAR(edit_chart_date_statusbar), 1, tstring2);
		sprintf(tstring, "%6.4f", tfloat);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_open_value_entry), tstring);
		sprintf(tstring, "%6.4f", tfloat2);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_high_value_entry), tstring);
		sprintf(tstring, "%6.4f", tfloat3);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_low_value_entry), tstring);
		sprintf(tstring, "%6.4f", tfloat4);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_close_value_entry), tstring);
		sprintf(tstring, "%ld", tlong2);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_volume_value_entry), tstring);
		sprintf(tstring, "%ld", tlong3);
		gtk_entry_set_text (GTK_ENTRY(edit_chart_openi_value_entry), tstring);
	}
}
/****************************************************************************************/
void edit_data_start()
{
	char tstring[250], tstring2[25], symbol[25];
	unsigned long tlong, tlong2, tlong3, records;
	float tfloat, tfloat2, tfloat3, tfloat4;
	FILE *infile;
    	extern char *datapath, *error_message, cant_open_chart[], edit_symbol[SYMBOL_SIZE];
    	extern long edit_record;
    	extern display_message();
    	extern GtkWidget *edit_chart_date_statusbar;
    	extern GtkWidget *edit_chart_open_value_entry, *edit_chart_record_statusbar;
    	extern GtkWidget *edit_chart_high_value_entry, *edit_chart_low_value_entry;
    	extern GtkWidget *edit_chart_close_value_entry, *edit_chart_volume_value_entry;
    	extern GtkWidget *edit_chart_openi_value_entry;

	
	if (edit_record == 0)
		return;
	strcpy(symbol, edit_symbol);
	strcpy(tstring, datapath);
    	strcat(tstring, symbol);
    	infile = fopen(tstring, "rb");
    	if (! infile)
    	{
    		error_message = cant_open_chart;
		display_message();
		return;
    	}
    	fseek(infile, 0L, SEEK_END);
    	tlong = ftell(infile);
    	tlong = tlong - HEADERSIZE;
    	records = tlong / RECORDSIZE;
    	fseek(infile, HEADERSIZE, SEEK_SET);
	fread(&tlong, sizeof(unsigned long), 1, infile);
	fread(&tfloat, sizeof(float), 1, infile);
	fread(&tfloat2, sizeof(float), 1, infile);
	fread(&tfloat3, sizeof(float), 1, infile);
	fread(&tfloat4, sizeof(float), 1, infile);
	fread(&tlong2, sizeof(unsigned long), 1, infile);
	fread(&tlong3, sizeof(unsigned long), 1, infile);
	fclose(infile);
	edit_record = 1;
	sprintf(tstring, "%ld", edit_record);
      	strcat(tstring, " / ");
      	sprintf(tstring2, "%ld", records);
      	strcat(tstring, tstring2);
	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_record_statusbar), 1, tstring);
	sprintf(tstring, "%ld", tlong);
	tstring2[0] = tstring[4];
        tstring2[1] = tstring[5];
        tstring2[2] = '/';
        tstring2[3] = tstring[6];
        tstring2[4] = tstring[7];
        tstring2[5] = '/';
        tstring2[6] = tstring[0];
        tstring2[7] = tstring[1];
        tstring2[8] = tstring[2];
        tstring2[9] = tstring[3];
        tstring2[10] = 0;
	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_date_statusbar), 1, tstring2);
	sprintf(tstring, "%6.4f", tfloat);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_open_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_high_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_low_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat4);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_close_value_entry), tstring);
	sprintf(tstring, "%ld", tlong2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_volume_value_entry), tstring);
	sprintf(tstring, "%ld", tlong3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_openi_value_entry), tstring);
}
/********************************************************************************************/
void edit_data_delete()
{
    	extern GtkWidget *yesno_window;
    	extern exit_yesno_window();
    	GtkWidget *hbox, *vbox, *label, *button, *button2, *hsep;
	extern int yesno_flag;
    	

	yesno_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (yesno_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
	gtk_signal_connect (GTK_OBJECT (yesno_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
	gtk_window_position(GTK_WINDOW (yesno_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (yesno_window), " ");
	gtk_widget_set_usize(GTK_WIDGET (yesno_window), 300, 0);
	
	
	vbox = gtk_vbox_new (FALSE, 10);
	gtk_container_add (GTK_CONTAINER (yesno_window), vbox);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_widget_show (vbox);
      	
	label = gtk_label_new("Are you sure you want to delete this record ?");
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, TRUE, 10);
        gtk_widget_show(label);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
        
      	button = gtk_button_new_with_label("Yes");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (yes_delete_record), NULL);
      	gtk_widget_show (button);
      	
      	button2 = gtk_button_new_with_label("No");
      	gtk_box_pack_start (GTK_BOX (hbox), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
      	gtk_widget_show (button2);
      	
      	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default (button2);
      	yesno_flag = 1;
      	gtk_widget_show(yesno_window);
}
/*************************************************************************************/
void edit_data_save()
{
	gchar tstring[250], tstring2[250], *tstringpointer;
	FILE *outfile;
	int tint;
	unsigned long volume, openi;
	float open, high, low, close;
    	extern long edit_record;
    	extern int open_file_flag, data_window_flag;
    	extern unsigned long edit_date;
    	extern GtkWidget *edit_chart_name_value_entry;
    	extern GtkWidget *edit_chart_open_value_entry, *edit_chart_high_value_entry;
    	extern GtkWidget *edit_chart_low_value_entry, *edit_chart_close_value_entry;
    	extern GtkWidget *edit_chart_volume_value_entry, *edit_chart_openi_value_entry;
    	extern char edit_symbol[SYMBOL_SIZE], edit_name[NAME_SIZE], *global_string;
    	extern char *datapath, *error_message, cant_open_chart[], symbol[SYMBOL_SIZE];
    	extern display_message(), load_file(), draw(), show_data_window();
    	
    	
    	
	tstringpointer = gtk_entry_get_text (GTK_ENTRY(edit_chart_name_value_entry));
	strcpy(tstring, tstringpointer);
	strncpy(edit_name, tstring, NAME_SIZE);
	strcpy(tstring, datapath);
	strcat(tstring, edit_symbol);
	outfile = fopen(tstring, "r+b");
	if (! outfile)
	{
		error_message = cant_open_chart;
		display_message();
		return;
	}
	fwrite(&edit_name, NAME_SIZE, 1, outfile);
	fseek(outfile, ((long)(edit_record - 1) * RECORDSIZE) + HEADERSIZE, SEEK_SET);
	tstringpointer = gtk_entry_get_text (GTK_ENTRY(edit_chart_open_value_entry));
	strcpy(tstring, tstringpointer);
	open = atof(tstring);
	tstringpointer = gtk_entry_get_text (GTK_ENTRY(edit_chart_high_value_entry));
	strcpy(tstring, tstringpointer);
	high = atof(tstring);
	tstringpointer = gtk_entry_get_text (GTK_ENTRY(edit_chart_low_value_entry));
	strcpy(tstring, tstringpointer);
	low = atof(tstring);
	tstringpointer = gtk_entry_get_text (GTK_ENTRY(edit_chart_close_value_entry));
	strcpy(tstring, tstringpointer);
	close = atof(tstring);
	tstringpointer = gtk_entry_get_text (GTK_ENTRY(edit_chart_volume_value_entry));
	strcpy(tstring, tstringpointer);
	volume = atol(tstring);
	tstringpointer = gtk_entry_get_text (GTK_ENTRY(edit_chart_openi_value_entry));
	strcpy(tstring, tstringpointer);
	openi = atol(tstring);
	fwrite(&edit_date, sizeof(unsigned long), 1, outfile);
	fwrite(&open, sizeof(float), 1, outfile);
	fwrite(&high, sizeof(float), 1, outfile);
	fwrite(&low, sizeof(float), 1, outfile);
	fwrite(&close, sizeof(float), 1, outfile);
	fwrite(&volume, sizeof(unsigned long), 1, outfile);
	fwrite(&openi, sizeof(unsigned long),1,outfile);
	fclose(outfile);
	
	strcpy(tstring, symbol);
	strcpy(tstring2, edit_symbol);
	if (! strcmp(tstring, tstring2))
	{
		if (global_string != NULL)
			free(global_string);
		global_string = (char *)malloc(sizeof(symbol) + 1);
		strcpy(global_string, symbol);
		tint = open_file_flag;
		open_file_flag = 1;
		load_file();
		open_file_flag = tint;
		draw();
		if (data_window_flag)
			show_data_window();
	}
}
/**************************************************************************************/
void edit_chart_data()
{
	char *tstringpointer, tstring[250], tstring2[25];
    	int tint;
    	unsigned long tlong, tlong2, tlong3;
    	float tfloat, tfloat2, tfloat3, tfloat4;
    	FILE *infile;
    	GtkWidget *vbox, *vbox2, *hbox, *frame, *hbox2, *hbox3, *hbox4, *hbox6;
    	GtkWidget *hbox7, *hbox8, *hbox9, *hbox10, *hbox11, *vbox3, *vbox4, *frame2;
    	GtkWidget *label, *label3, *label4, *label5, *label6, *label7, *label8, *label9;
    	GtkWidget *label10, *label2, *close_button, *save_button, *delete_button;
    	GtkWidget *start_button, *next_button, *back_button, *end_button, *help_button;
    	GtkWidget *edit_chart_symbol_statusbar;
    	GList *list;
    	extern GtkWidget *workwith_charts_clist, *edit_chart_window;
    	extern GtkWidget *edit_chart_name_value_entry;
    	extern GtkWidget *edit_chart_open_value_entry, *edit_chart_high_value_entry;
    	extern GtkWidget *edit_chart_low_value_entry, *edit_chart_close_value_entry;
    	extern GtkWidget *edit_chart_volume_value_entry, *edit_chart_openi_value_entry;
    	extern GtkWidget *edit_chart_date_statusbar, *edit_chart_record_statusbar;
    	extern exit_dialog(), display_message(), edit_dat(), exit_workwith_charts_window();
    	extern exit_edit_chart_window(), help_edit_chart_window();
    	extern long edit_record;
    	extern unsigned long edit_date;
    	extern int edit_chart_flag;
    	extern char edit_symbol[SYMBOL_SIZE], edit_name[NAME_SIZE], cant_open_chart[];
    	extern char *error_message, *datapath, *error_message, nothing_selected[];
    	
    	
    	
    	if (edit_chart_flag)
    		return;
    	list = GTK_CLIST (workwith_charts_clist)->selection;
    	if (! list)
    	{
    		error_message = nothing_selected;
		display_message();
		return;
    	}
	tint = (int) list->data;
      	gtk_clist_get_text(GTK_CLIST(workwith_charts_clist), tint, 0, &tstringpointer);
 	strcpy(edit_symbol, tstringpointer);
 	exit_workwith_charts_window();
	 		
	edit_chart_window = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (edit_chart_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_edit_chart_window), NULL);
        gtk_signal_connect (GTK_OBJECT (edit_chart_window), "destroy",
			    GTK_SIGNAL_FUNC(exit_edit_chart_window), NULL);
        gtk_window_set_title (GTK_WINDOW (edit_chart_window), "Edit Chart Data");
        gtk_window_position(GTK_WINDOW (edit_chart_window), GTK_WIN_POS_CENTER);
        gtk_container_border_width (GTK_CONTAINER (edit_chart_window), 0);
        gtk_widget_set_usize(GTK_WIDGET (edit_chart_window), 400, 0);
        
        vbox = gtk_vbox_new (FALSE, 10);
        gtk_container_add (GTK_CONTAINER (edit_chart_window), vbox);
        gtk_container_border_width (GTK_CONTAINER (vbox), 10);
        gtk_widget_show (vbox);
        
        frame = gtk_frame_new (NULL);
      	gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, TRUE, 0);
      	gtk_widget_show (frame);
      	
      	vbox2 = gtk_vbox_new (FALSE, 5);
        gtk_container_add (GTK_CONTAINER (frame), vbox2);
        gtk_container_border_width (GTK_CONTAINER (vbox2), 5);
        gtk_widget_show (vbox2);
        
        hbox2 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox2), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), hbox2, FALSE, TRUE, 0);
      	gtk_widget_show (hbox2);
      	
      	label = gtk_label_new ("Name:");
      	gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, TRUE, 0);
      	gtk_widget_show (label);
      	
      	edit_chart_name_value_entry = gtk_entry_new ();
      	gtk_box_pack_start (GTK_BOX (hbox2), edit_chart_name_value_entry, TRUE, TRUE, 0);
      	gtk_widget_show (edit_chart_name_value_entry);
      	
      	hbox3 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox3), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, TRUE, 0);
      	gtk_widget_show (hbox3);
      	
      	label2 = gtk_label_new ("Symbol:");
      	gtk_box_pack_start (GTK_BOX (hbox3), label2, FALSE, TRUE, 0);
      	gtk_widget_show (label2);
      	
      	edit_chart_symbol_statusbar = gtk_statusbar_new ();
      	gtk_box_pack_start (GTK_BOX (hbox3), edit_chart_symbol_statusbar, TRUE, TRUE, 0);
      	gtk_widget_show (edit_chart_symbol_statusbar);
      	
        hbox = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox), 0);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_widget_show (hbox);
      	
      	frame2 = gtk_frame_new (NULL);
      	gtk_box_pack_start (GTK_BOX (hbox), frame2, TRUE, TRUE, 0);
      	gtk_widget_show (frame2);

	vbox3 = gtk_vbox_new (FALSE, 5);
        gtk_container_add (GTK_CONTAINER (frame2), vbox3);
        gtk_container_border_width (GTK_CONTAINER (vbox3), 10);
        gtk_widget_show (vbox3);
	
      	vbox4 = gtk_vbutton_box_new ();
      	gtk_box_pack_start (GTK_BOX (hbox), vbox4, FALSE, TRUE, 0);
        gtk_vbutton_box_set_spacing_default(5);
      	gtk_vbutton_box_set_layout_default(GTK_BUTTONBOX_START);
        gtk_widget_show (vbox4);
        
        start_button = gtk_button_new_with_label ("Start");
      	gtk_signal_connect (GTK_OBJECT (start_button), "clicked",
			    	    GTK_SIGNAL_FUNC (edit_data_start), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), start_button, FALSE, TRUE, 0);
      	gtk_widget_show (start_button);
      	
      	next_button = gtk_button_new_with_label ("Next");
      	gtk_signal_connect (GTK_OBJECT (next_button), "clicked",
			    	    GTK_SIGNAL_FUNC (edit_data_next), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), next_button, FALSE, TRUE, 0);
      	gtk_widget_show (next_button);
      	
      	back_button = gtk_button_new_with_label ("Back");
      	gtk_signal_connect (GTK_OBJECT (back_button), "clicked",
			    	    GTK_SIGNAL_FUNC (edit_data_back), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), back_button, FALSE, TRUE, 0);
      	gtk_widget_show (back_button);
      	
      	end_button = gtk_button_new_with_label ("End");
      	gtk_signal_connect (GTK_OBJECT (end_button), "clicked",
			    	    GTK_SIGNAL_FUNC (edit_data_end), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), end_button, FALSE, TRUE, 0);
      	gtk_widget_show (end_button);
      	
      	save_button = gtk_button_new_with_label ("Save");
      	gtk_signal_connect (GTK_OBJECT (save_button), "clicked",
			    	    GTK_SIGNAL_FUNC (edit_data_save), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), save_button, FALSE, TRUE, 0);
      	gtk_widget_show (save_button);
      	
      	delete_button = gtk_button_new_with_label ("Delete");
      	gtk_signal_connect (GTK_OBJECT (delete_button), "clicked",
			    	    GTK_SIGNAL_FUNC (edit_data_delete), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), delete_button, FALSE, TRUE, 0);
      	gtk_widget_show (delete_button);
      	
      	close_button = gtk_button_new_with_label ("Close");
      	gtk_signal_connect (GTK_OBJECT (close_button), "clicked",
			    	    GTK_SIGNAL_FUNC (exit_edit_chart_window), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), close_button, FALSE, TRUE, 0);
      	gtk_widget_show (close_button);
      	
      	help_button = gtk_button_new_with_label ("Help");
      	gtk_signal_connect (GTK_OBJECT (help_button), "clicked",
			    	    GTK_SIGNAL_FUNC (help_edit_chart_window), NULL);
      	gtk_box_pack_start (GTK_BOX (vbox4), help_button, FALSE, TRUE, 0);
      	gtk_widget_show (help_button);
        
      	hbox4 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox4), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), hbox4, FALSE, TRUE, 0);
      	gtk_widget_show (hbox4);
      	
      	label3 = gtk_label_new ("Record:");
      	gtk_box_pack_start (GTK_BOX (hbox4), label3, FALSE, TRUE, 0);
      	gtk_widget_show (label3);
      	
      	edit_chart_record_statusbar = gtk_statusbar_new ();
      	gtk_box_pack_start (GTK_BOX (hbox4), edit_chart_record_statusbar, TRUE, TRUE, 0);
      	gtk_widget_show (edit_chart_record_statusbar);
      	
      	label4 = gtk_label_new ("Date:");
      	gtk_box_pack_start (GTK_BOX (hbox4), label4, FALSE, TRUE, 0);
      	gtk_widget_show (label4);
      	
      	edit_chart_date_statusbar = gtk_statusbar_new ();
      	gtk_box_pack_start (GTK_BOX (hbox4), edit_chart_date_statusbar, TRUE, TRUE, 0);
      	gtk_widget_show (edit_chart_date_statusbar);
      	
      	hbox6 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox6), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), hbox6, FALSE, TRUE, 0);
      	gtk_widget_show (hbox6);
      	
      	edit_chart_open_value_entry = gtk_entry_new ();
      	gtk_box_pack_end (GTK_BOX (hbox6), edit_chart_open_value_entry, FALSE, TRUE, 0);
      	gtk_widget_show (edit_chart_open_value_entry);
      	
      	label5 = gtk_label_new ("Open:");
      	gtk_box_pack_end (GTK_BOX (hbox6), label5, FALSE, TRUE, 0);
      	gtk_widget_show (label5);
      	
      	hbox7 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox7), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), hbox7, FALSE, TRUE, 0);
      	gtk_widget_show (hbox7);
      	      	
      	edit_chart_high_value_entry = gtk_entry_new ();
      	gtk_box_pack_end (GTK_BOX (hbox7), edit_chart_high_value_entry, FALSE, TRUE, 0);
      	gtk_widget_show (edit_chart_high_value_entry);
      	
      	label6 = gtk_label_new ("High:");
      	gtk_box_pack_end (GTK_BOX (hbox7), label6, FALSE, TRUE, 0);
      	gtk_widget_show (label6);
      	
      	hbox8 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox8), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), hbox8, FALSE, TRUE, 0);
      	gtk_widget_show (hbox8);
      	
      	edit_chart_low_value_entry = gtk_entry_new ();
      	gtk_box_pack_end (GTK_BOX (hbox8), edit_chart_low_value_entry, FALSE, TRUE, 0);
      	gtk_widget_show (edit_chart_low_value_entry);
      	
      	label7 = gtk_label_new ("Low:");
      	gtk_box_pack_end (GTK_BOX (hbox8), label7, FALSE, TRUE, 0);
      	gtk_widget_show (label7);
      	
      	hbox9 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox9), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), hbox9, FALSE, TRUE, 0);
      	gtk_widget_show (hbox9);
      	
      	edit_chart_close_value_entry = gtk_entry_new ();
      	gtk_box_pack_end (GTK_BOX (hbox9), edit_chart_close_value_entry, FALSE, TRUE, 0);
      	gtk_widget_show (edit_chart_close_value_entry);
      	
      	label8 = gtk_label_new ("Close:");
      	gtk_box_pack_end (GTK_BOX (hbox9), label8, FALSE, TRUE, 0);
      	gtk_widget_show (label8);
      	
      	hbox10 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox10), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), hbox10, FALSE, TRUE, 0);
      	gtk_widget_show (hbox10);
      	
      	edit_chart_volume_value_entry = gtk_entry_new ();
      	gtk_box_pack_end (GTK_BOX (hbox10), edit_chart_volume_value_entry, FALSE, TRUE, 0);
      	gtk_widget_show (edit_chart_volume_value_entry);
      	
      	label9 = gtk_label_new ("Volume:");
      	gtk_box_pack_end (GTK_BOX (hbox10), label9, FALSE, TRUE, 0);
      	gtk_widget_show (label9);
      	
      	hbox11 = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox11), 0);
      	gtk_box_pack_start (GTK_BOX (vbox3), hbox11, FALSE, TRUE, 0);
      	gtk_widget_show (hbox11);
      	
      	edit_chart_openi_value_entry = gtk_entry_new ();
      	gtk_box_pack_end (GTK_BOX (hbox11), edit_chart_openi_value_entry, FALSE, TRUE, 0);
      	gtk_widget_show (edit_chart_openi_value_entry);
      	
      	label10 = gtk_label_new ("Open Interest:");
      	gtk_box_pack_end (GTK_BOX (hbox11), label10, FALSE, TRUE, 0);
      	gtk_widget_show (label10);
      	
      	strcpy(tstring, datapath);
      	strcat(tstring, edit_symbol);
      	infile = fopen(tstring, "rb");
      	if (! infile)
      	{
      		error_message = cant_open_chart;
		display_message();
		return;
      	}
      	fseek(infile, 0L, SEEK_END);
      	tlong = ftell(infile);
      	tlong = tlong - HEADERSIZE;
      	tint = tlong / RECORDSIZE;
      	edit_record = 1;
      	sprintf(tstring, "%ld", edit_record);
      	strcat(tstring, " / ");
      	sprintf(tstring2, "%d", tint);
      	strcat(tstring, tstring2);
      	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_record_statusbar), 1, tstring);
      	fseek(infile, 0L, SEEK_SET);
      	fread(&edit_name, NAME_SIZE, 1, infile);
      	fseek(infile, HEADERSIZE, SEEK_SET);
      	fread(&tlong, sizeof(unsigned long), 1, infile);
	fread(&tfloat, sizeof(float), 1, infile);
	fread(&tfloat2, sizeof(float), 1, infile);
	fread(&tfloat3, sizeof(float), 1, infile);
	fread(&tfloat4, sizeof(float), 1, infile);
	fread(&tlong2, sizeof(unsigned long), 1, infile);
	fread(&tlong3, sizeof(unsigned long), 1, infile);
	sprintf(tstring, "%ld", tlong);
	edit_date = tlong;
	tstring2[0] = tstring[4];
        tstring2[1] = tstring[5];
        tstring2[2] = '/';
        tstring2[3] = tstring[6];
        tstring2[4] = tstring[7];
        tstring2[5] = '/';
        tstring2[6] = tstring[0];
        tstring2[7] = tstring[1];
        tstring2[8] = tstring[2];
        tstring2[9] = tstring[3];
        tstring2[10] = 0;
	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_date_statusbar), 1, tstring2);
	sprintf(tstring, "%6.4f", tfloat);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_open_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_high_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_low_value_entry), tstring);
	sprintf(tstring, "%6.4f", tfloat4);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_close_value_entry), tstring);
	sprintf(tstring, "%ld", tlong2);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_volume_value_entry), tstring);
	sprintf(tstring, "%ld", tlong3);
	gtk_entry_set_text (GTK_ENTRY(edit_chart_openi_value_entry), tstring);
	fclose(infile);
   	gtk_entry_set_text (GTK_ENTRY(edit_chart_name_value_entry), edit_name);
   	gtk_statusbar_push (GTK_STATUSBAR(edit_chart_symbol_statusbar), 1, edit_symbol);
   	
   	edit_chart_flag = 1;
    	gtk_widget_show(edit_chart_window);
}